# TQMa6ULx / TQMa6ULLx / TQMa6ULxL / TQMa6ULLxL

[[_TOC_]]

## Overview

### Supported Hardware

* TQMa6ULx REV.030x on MBa6ULx REV.020x carrier board (aka STKa6ULx)
* TQMa6ULLx REV.030x on MBa6ULx REV.020x carrier board (aka STKa6ULLx)
* TQMa6ULxL REV.020x on MBa6ULx REV.020x carrier board (aka STKa6ULxL)
* TQMa6ULLxL REV.020x on MBa6ULx REV.020x carrier board (aka STKa6ULLxL)
* TQMa6ULxL REV.020x on MBa6ULxL REV.020x carrier board

### Versions

_Bootloader:_

* uboot-imx (2016.03 + rel\_imx\_4.1.15_2.0.0\_ga + patches)

_Kernel:_

* Mainline: linux 5.15.55 + Patches
* Mainline + PREEMPT-RT: linux 5.15.55 + -rt48 + Patches

### Known issues

* U-Boot: default device tree names for all machines using the starter kit
mainboard (aka MBa6ULx) do not match device tree names in current supported
mainline kernel version.
* Linux: Booting with rootfs over NFS does not work reliable with systemd when
booting CPU with two ethernet interfaces. Needs modification of kernel command
line and networkd unit file. Reason for this is the fact that ENET2 is detected
before ENET1 and both share the same MDIO bus. Network device numbering in U-Boot
is inverse to Linux.
* Linux / DTB: when booting kernel versions from this BSP the disabling of fused IP in
device tree before loding the OS may fail with U-Boot from older BSP versions.
Device tree path names were changed in CPU device tree fragment to conform the
device tree specification.
* Loading the cpufreq driver fails . This means that the CPU frequency cannot be output.

## Usage

### Configuration

Configure BSP for usage with TQMa6UL\[L\]x\[L\] / MBa6ULx\[L\] by calling:

_MBa6ULx:_

* for linux/mainline with busybox init without Qt:      `tools/config-mba6ulx.tiny`
* for linux/mainline with busybox init with Qt enabled: `tools/config-mba6ulx.qt`
* for linux/mainline with systemd init without Qt:      `tools/config-mba6ulx.sd`

_MBa6ULxL:_

* for linux/mainline with busybox init without Qt:      `tools/config-mba6ulxl.tiny`
* for linux/mainline with busybox init with Qt enabled: `tools/config-mba6ulxl.qt`

### Build

Build the BSP by calling

`./p images`

## Artifacts (MBa6ULx)

The build results are located in
`./platform-MBa6ULx/images`

### U-Boot images (MBa6ULx)

| _Board variants with 265 MB RAM_         |                                                                                |
| :--------------------------------------- | :----------------------------------------------------------------------------- |
| u-boot-fsl-mba6ul\[l\]x\[-lga\]-mmc.imx  | U-Boot for SD / e-MMC boot (TQMa6UL\[L\]x\[L\] on MBa6ULx)                     |
| u-boot-fsl-mba6ul\[l\]x\[-lga\]-qspi.imx | U-Boot for QSPI boot (TQMa6UL\[L\]x\[L\] on MBa6ULx with QSPI NOR config data) |

| _Board variants with 512 MB RAM_        |                                                                           |
| :-------------------------------------- | :------------------------------------------------------------------------ |
| u-boot-fsl-512mb-mba6ul\[l\]lx-mmc.imx  | U-Boot for SD / e-MMC boot (TQMa6UL\[L\]x on MBa6ULx)                     |
| u-boot-fsl-512mb-mba6ul\[l\]lx-qspi.imx | U-Boot for QSPI boot (TQMa6UL\[L\]x on MBa6ULx with QSPI NOR config data) |

### Linux zImages (MBa6ULx)

|               |                              |
| :------------ | :--------------------------- |
| linuximage    | for Mainline                 |
| linuximage-rt | for Mainline with PREEMPT-RT |

### Device tree blobs (MBa6ULx)


| _TQMA6ULx\[L\]_                               |                                                                                  |
| :-------------------------------------------- | :------------------------------------------------------------------------------- |
| imx6ul-tqma6ul1-mba6ulx.dtb                   | without display - TQMa6UL1\[L\] (only one ethernet port, use different MDIO bus) |
| imx6ul-tqma6ul2\[-l\]-mba6ulx.dtb             | without display                                                                  |
| imx6ul-tqma6ul2\[-l\]-mba6ulx-lvds.dtb        | with LVDS display (Tianma tm070jvhg33)                                           |
| imx6ul-tqma6ul2\[-l\]-mba6ulx-cdtech-fc21.dtb | with parallel display (DMB S070WS12H-O-CT21/S070PWS19HP-FC21)                    |
| imx6ul-tqma6ul2\[-l\]-mba6ulx-cdtech-dc44.dtb | with parallel display (DMB S070WV106H-CT44/S070SWV29HG-DC44)                     |

| _TQMA6ULLx\[L\]_                                  |                                                               |
| :------------------------------------------------ | :------------------------------------------------------------ |
| imx6ull-tqma6ull2\[-l\]-mba6ulx.dtb               | without display                                               |
| imx6ull-tqma6ull2\[-l\]-mba6ulx-lvds.dtb          | with LVDS display (Tianma tm070jvhg33)                        |
| imx6ull-tqma6ull2\[-l\]-mba6ulx-cdtech-fc21.dtb   | with parallel display (DMB S070WS12H-O-CT21/S070PWS19HP-FC21) |
| imx6ull-tqma6ull2\[-l\]-mba6ulx-cdtech-dc44.dtb   | with parallel display (DMB S070WV106H-CT44/S070SWV29HG-DC44)  |

### Firmware (containing Linux zImages & Device tree blobs) (MBa6ULx)

|              |
| :----------- |
| firmware.img |
| firmware.tgz |

### RootFS (MBa6ULx)

|            |                                |
| :--------- | :----------------------------- |
| root.ext2  | EXT file system for SD / e-MMC |
| root.tgz   | tgz for NFS mount              |
| root.ubifs | ubifs image for QSPI NOR       |
| root.ubi   | ubi partition for QSPI NOR     |

### SD / e-MMC system images (bootloader, firmware partition, RootFS) (MBa6ULx)

|                               |                                 |
| :---------------------------- | :------------------------------ |
| uboot-mba6ulx\[-lga\]-hd.img  | TQMa6ULx\[L\] on MBa6ULx        |
| uboot-mba6ullx\[-lga\]-hd.img | TQMa6ULLx\[L\] on MBa6ULx       |
| uboot-512mb-mba6ulx-hd.img    | TQMa6ULx with 512MB on MBa6ULx  |
| uboot-512mb-mba6ullx-hd.img   | TQMa6ULLx with 512MB on MBa6ULx |

### QSPI NOR System images (QSPI NOR config, bootloader, device tree, kernel) (MBa6ULx)

|                                 |                                 |
| :------------------------------ | :------------------------------ |
| uboot-mba6ulx\[-lga\]-qspi.img  | TQMa6ULx\[L\] on MBa6ULx        |
| uboot-mba6ullx\[-lga\]-qspi.img | TQMa6ULLx\[L\] on MBa6ULx       |
| uboot-512mb-mba6ulx-qspi.img    | TQMa6ULx with 512MB on MBa6ULx  |
| uboot-512mb-mba6ullx-qspi.img   | TQMa6ULLx with 512MB on MBa6ULx |

## Artifacts (MBa6ULxL)

The build results are located in
`./platform-MBa6ULxL/images`:

### U-Boot images (MBa6ULxL)

|                             |                            |
| :-------------------------- | :------------------------- |
| u-boot-fsl-mba6ulxl-mmc.imx | U-Boot for SD / e-MMC boot |
|                             | No QSPI boot image!        |

### Linux zImages (MBa6ULxL)

|               |                              |
| :------------ | :--------------------------- |
| linuximage    | for Mainline                 |
| linuximage-rt | for Mainline with PREEMPT-RT |

### Device tree blobs (MBa6ULxL)

|                                        |                                            |
| :------------------------------------- | :----------------------------------------- |
| imx6ul-mba6ulxl.dtb                    | without display                            |
| imx6ul-mba6ulxl-glyn-etm0700g0edh6.dtb | with parallel display (GLYN ETM0700G0EDH6) |

### Firmware (containing Linux zImages & Device tree blobs) (MBa6ULxL)

|              |
| :----------- |
| firmware.img |
| firmware.tgz |

### RootFS (MBa6ULxL)

|           |                                |
| :-------- | :----------------------------- |
| root.ext2 | EXT file system for SD / e-MMC |
| root.tgz  | tgz for NFS mount              |

### SD / e-MMC system images (bootloader, firmware partition, RootFS) (MBa6ULxL)

|                       |          |
| :-------------------- | :------- |
| uboot-mba6ulxl-hd.img | MBa6ULxL |

## HowTo

### MBa6ULx DIP Switch settings for Boot

_Note:_

* S12: BOOT_CFG1\[0 .. 7\]
* S11: BOOT_CFG2\[0 .. 7\]
* S13: BOOT_CFG4\[0 .. 7\]
* S5: BOOT\_MODE\[0 .. 1\]
* X means position of DIP, - means don't care

#### SD Card

|         | S11 |     |     |     |     |     |     |     |   | S12 |     |     |     |     |     |     |     |    | S13 |     |     |     |     |     |     |     |    |  S5 |     |
| ------- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | - | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | -- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | -- | :-: | :-: |
| DIP     |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |   |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |    |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |    |  1  |  2  |
| ON      |  x  |  x  |     |  x  |  x  |  x  |  x  |  x  |   |  x  |  x  |     |  x  |  x  |  x  |     |  x  |    |  x  |  x  |  x  |  x  |  x  |  x  |  x  |  x  |    |     |  x  |
| OFF     |     |     |  x  |     |     |     |     |     |   |     |     |  x  |     |     |     |  x  |     |    |     |     |     |     |     |     |     |     |    |  x  |     |

#### e-MMC

|         | S11 |     |     |     |     |     |     |     |   | S12 |     |     |     |     |     |     |     |    | S13 |     |     |     |     |     |     |     |    |  S5 |     |
| ------- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | - | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | -- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | -- | :-: | :-: |
| DIP     |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |   |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |    |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |    |  1  |  2  |
| ON      |  x  |     |  x  |  x  |     |  x  |  x  |  x  |   |  x  |  x  |  x  |  x  |  x  |     |     |  x  |    |  x  |  x  |  x  |  x  |  x  |  x  |  x  |  x  |    |     |  x  |
| OFF     |     |  x  |     |     |  x  |     |     |     |   |     |     |     |     |     |  x  |  x  |     |    |     |     |     |     |     |     |     |     |    |  x  |     |


#### QSPI

|         | S11 |     |     |     |     |     |     |     |   | S12 |     |     |     |     |     |     |     |    | S13 |     |     |     |     |     |     |     |    |  S5 |     |
| ------- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | - | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | -- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | -- | :-: | :-: |
| DIP     |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |   |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |    |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |    |  1  |  2  |
| ON      |  x  |  x  |  x  |  x  |  x  |  x  |  x  |  x  |   |  x  |  x  |  x  |  x  |     |  x  |  x  |  x  |    |  x  |  x  |  x  |  x  |  x  |  x  |  x  |  x  |    |     |  x  |
| OFF     |     |     |     |     |     |     |     |     |   |     |     |     |     |  x  |     |     |     |    |     |     |     |     |     |     |     |     |    |  x  |     |


### MBa6ULxL DIP Switch settings for Boot

_Note:_

* S16 are for BOOT_CFG 0..07.
* S13 is for Boot Mode.
* X means position of DIP, - means don't care

#### SD Card

|         | S16 |     |     |     |     |     |     |     |   | S13 |     |
| ------- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | - | :-: | :-: |
| DIP     |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |   |  1  |  2  |
| ON      |  -  |  x  |     |  x  |  x  |     |     |  x  |   |     |  x  |
| OFF     |  -  |     |  x  |     |     |  x  |  x  |     |   |  x  |     |

#### e-MMC

|         | S16 |     |     |     |     |     |     |     |   | S13 |     |
| ------- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | - | :-: | :-: |
| DIP     |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |   |  1  |  2  |
| ON      |  -  |     |  x  |     |     |     |  x  |  x  |   |     |  x  |
| OFF     |  -  |  x  |     |  x  |  x  |  x  |     |     |   |  x  |     |

#### QSPI

|         | S16 |     |     |     |     |     |     |     |   | S13 |     |
| ------- | :-: | :-: | :-: | :-: | :-: | :-: | :-: | :-: | - | :-: | :-: |
| DIP     |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |   |  1  |  2  |
| ON      |  -  |  -  |  -  |  -  |  x  |  x  |  x  |     |   |     |  x  |
| OFF     |  -  |  -  |  -  |  -  |     |     |     |  x  |   |  x  |     |


### Initially program boot loader image

#### QSPI NOR

##### Bootloader

To initialize QSPI NOR with bootloader, write
[bootloader image (MBa6ULx)](#U-Boot images (MBa6ULx)) or
[bootloader image (MBa6ULxL)](#U-Boot images (MBa6ULxL))
to QSPI NOR at offset 0x00:

```
setenv uboot <qspi u-boot image>
tftp ${loadaddr} ${uboot}
sf probe
sf update ${loadaddr} 0 ${filesize}
```

#### SD / e-MMC

To initialize SD / e-MMC with bootloader, write
[bootloader image (MBa6ULx)](#U-Boot images (MBa6ULx)) or
[bootloader image (MBa6ULxL)](#U-Boot images (MBa6ULxL))
to SD / e-MMC at offset 0x400 / block #2

```
setenv uboot <sd/e-mmc u-boot image>
tftp ${loadaddr} ${uboot}
mmc dev [0,1]
mmc rescan
setenv blkc ${filesize} + 1ff
setenv blkc ${blkc} / 200
mmc write ${loadaddr} 2 ${blkc}
setenv blkc
```

### Program complete system image

#### QSPI NOR

To Program complete system image to QSPI NOR, write `uboot-mba6ul[l]x[-lga]-qspi.img`
to QSPI NOR at offset 0x00

To program the rootfs as UBI, write [RootFS (MBa6ULx)](#RootFS (MBa6ULx)) or 
[RootFS (MBa6ULxL)](#RootFS (MBa6ULxL)) `.ubi` `.ubi` to `/dev/mtd5` (under linux)

Save `root.ubi` on a USB stick and mount it to `/mnt`

```
ubiformat /dev/mtd5 -f /<path>/root.ubi
```

To check usability of the programmed rootfs, one can use the command 
```
ubiattach /dev/ubi_ctrl -m 5
mount -t ubifs ubi0 /<mount directory>
```

#### SD / e-MMC

To program complete system image to SD / e-MMC, write `uboot-mba6ulx[-lga|l]-hd.img`
[SD / e-MMC system images (MBa6ULx)](#SD / e-MMC system images (bootloader, firmware partition, RootFS) (MBa6ULx)) 
or 
[SD / e-MMC system images (MBa6ULxL)](#SD / e-MMC system images (bootloader, firmware partition, RootFS) (MBa6ULxL)) 
to SD / e-MMC at offset 0x00 / block #0

```
dd if=<SD / e-MMC system images> of=/dev/mmcblk0 bs=4k conv=fsync
```

### Update parts of system

To update parts of system using U-Boot / TFTP following shortcuts exist, to
update the part on the active boot device.

[Linux image (MBa6ULx)](#Linux zImages (MBa6ULx))
[Linux image (MBa6ULxL)](#Linux zImages (MBa6ULxL))
```
setenv zimage <name of linux zimage>
run update_kernel
```

[Device tree blobs (MBa6ULx)](#Device tree blobs (MBa6ULx))
[Device tree blobs (MBa6ULxL)](#Device tree blobs (MBa6ULxL))
```
setenv fdt_file <name of fdt image>
run update_fdt
```

[bootloader image (MBa6ULx)](#U-Boot images (MBa6ULx))
[bootloader image (MBa6ULxL)](#U-Boot images (MBa6ULxL))
```
setenv uboot <name of u-boot image>
run update_uboot
```
================================================================================

See [TQ Embedded Wiki for TQMa6ULx and TQMa6ULx](https://support.tq-group.com/en/arm/tqma6ulx)  
See [TQ Embedded Wiki for TQMa6ULx and TQMa6ULxL](https://support.tq-group.com/en/arm/tqma6ulxl)
