# -*-makefile-*-
#
# Copyright (C) 2007 by Sascha Hauer
#
# Copyright (C) 2009-2010 by Marc Kleine-Budde <mkl@pengutronix.de>
#
# Copyright (C) 2016-2023 TQ-Systems GmbH <oss@ew.tq-group.com>, D-82229 Seefeld, Germany.
# Author: Markus Niebel, Gregor Herburger
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_U_BOOT_MBA335_MMC) += u-boot-mba335-mmc

#
# Paths and names
#
U_BOOT_MBA335_MMC_VERSION	:= $(call remove_quotes,$(PTXCONF_U_BOOT_MBA335_MMC_VERSION))
U_BOOT_MBA335_MMC_MD5		:= $(call remove_quotes,$(PTXCONF_U_BOOT_MBA335_MMC_MD5))
U_BOOT_MBA335_MMC		:= u-boot-$(U_BOOT_MBA335_MMC_VERSION)
U_BOOT_MBA335_MMC_SUFFIX	:= $(U_BOOT_TARBALL_SUFFIX)

ifdef U_BOOT_NEEDS_GIT_URL

U_BOOT_MBA335_MMC_URL	:= $(U_BOOT_GIT_URL);tag=$(U_BOOT_MBA335_MMC_VERSION)

else

U_BOOT_MBA335_MMC_URL	:= $(U_BOOT_FTP_BASE_URL)/$(U_BOOT_MBA335_MMC).$(U_BOOT_MBA335_MMC_SUFFIX)

endif

U_BOOT_MBA335_MMC_SOURCE	:= $(SRCDIR)/$(U_BOOT_MBA335_MMC).$(U_BOOT_MBA335_MMC_SUFFIX)
U_BOOT_MBA335_MMC_DIR	:= $(BUILDDIR)/u-boot-mb335-mmc$(U_BOOT_MBA335_MMC_VERSION)

U_BOOT_MBA335_MMC_LICENSE	:= $(U_BOOT_LICENSE)
U_BOOT_MBA335_MMC_LICENSE_FILES	:= $(U_BOOT_LICENSE_FILES)
U_BOOT_MBA335_MMC_DEVPKG	:= NO

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

U_BOOT_MBA335_MMC_PATH	:= PATH=$(CROSS_PATH)
U_BOOT_MBA335_MMC_MAKE_OPT	:= \
	CROSS_COMPILE=$(BOOTLOADER_CROSS_COMPILE) \
	HOSTCC=$(HOSTCC)
U_BOOT_MBA335_MMC_MAKE_PAR	:= NO
U_BOOT_MBA335_MMC_TAGS_OPT	:= ctags cscope etags

$(STATEDIR)/u-boot-mba335-mmc.prepare:
	@$(call targetinfo)
	cd $(U_BOOT_MBA335_MMC_DIR) && \
		$(U_BOOT_MBA335_MMC_PATH) \
		$(MAKE) $(U_BOOT_MBA335_MMC_MAKE_OPT) \
			$(call remove_quotes,$(PTXCONF_U_BOOT_MBA335_MMC_CONFIG))
	@$(call touch)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

$(STATEDIR)/u-boot-mba335-mmc.install:
	@$(call targetinfo)
	@$(call touch)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/u-boot-mba335-mmc.targetinstall:
	@$(call targetinfo)
	@install -D -m644 $(U_BOOT_MBA335_MMC_DIR)/u-boot.img $(IMAGEDIR)/$(PTXCONF_U_BOOT_MBA335_MMC_INSTALL_NAME).img
	@install -D -m644 $(U_BOOT_MBA335_MMC_DIR)/MLO $(IMAGEDIR)/$(PTXCONF_U_BOOT_MBA335_MMC_INSTALL_NAME)-MLO
	@$(call touch)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

$(STATEDIR)/u-boot-mba335-mmc.clean:
	@$(call targetinfo)
	@$(call clean_pkg, U_BOOT_MBA335_MMC)
	@rm -f $(IMAGEDIR)/$(PTXCONF_U_BOOT_MBA335_MMC_INSTALL_NAME).img
	@rm -f $(IMAGEDIR)/$(PTXCONF_U_BOOT_MBA335_MMC_INSTALL_NAME)-MLO

# vim: syntax=make
