# -*-makefile-*-
#
# Copyright (C) 2016-2022 TQ-Systems GmbH <oss@ew.tq-group.com>, D-82229 Seefeld, Germany.
# Author: Marco Felsch, Markus Niebel
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
IMAGE_PACKAGES-$(PTXCONF_IMAGE_UBOOT_1GB_MBA7X_QSPI) += image-uboot-1gb-mba7x-qspi

#
# Paths and names
#
IMAGE_UBOOT_1GB_MBA7X_QSPI		:= image-uboot-1gb-mba7x-qspi
IMAGE_UBOOT_1GB_MBA7X_QSPI_DIR		:= $(BUILDDIR)/$(IMAGE_UBOOT_1GB_MBA7X_QSPI)
IMAGE_UBOOT_1GB_MBA7X_QSPI_IMAGE	:= $(IMAGEDIR)/uboot-1gb-mba7x-qspi.img

IMAGE_UBOOT_1GB_MBA7X_QSPI_UBOOT_IMAGE = \
	$(call remove_quotes,$(PTXCONF_U_BOOT_FSL_1GB_MBA7_QSPI_INSTALL_NAME)).imx

IMAGE_UBOOT_1GB_MBA7X_QSPI_DATA	:= \
	$(IMAGEDIR)/$(IMAGE_UBOOT_1GB_MBA7X_QSPI_UBOOT_IMAGE) \
	$(IMAGEDIR)/linuximage \
	$(IMAGEDIR)/imx7d-mba7.dtb

IMAGE_UBOOT_1GB_MBA7X_QSPI_CONFIG	:= uboot-mba7-qspi.config

# ----------------------------------------------------------------------------
# Image
# ----------------------------------------------------------------------------

IMAGE_UBOOT_1GB_MBA7X_QSPI_ENV = \
	BOOT=$(IMAGEDIR)/$(IMAGE_UBOOT_1GB_MBA7X_QSPI_UBOOT_IMAGE) \
	KERNEL=linuximage \
	DTB=imx7d-mba7.dtb

$(IMAGE_UBOOT_1GB_MBA7X_QSPI_IMAGE):
	@$(call targetinfo)
	@$(call image/genimage, IMAGE_UBOOT_1GB_MBA7X_QSPI)
	@$(call finish)

# vim: syntax=make
