# -*-makefile-*-
#
# Copyright (C) 2007 by Sascha Hauer
#
# Copyright (C) 2009-2010 by Marc Kleine-Budde <mkl@pengutronix.de>
#
# Copyright (C) 2015-2022 TQ-Systems GmbH <oss@ew.tq-group.com>, D-82229 Seefeld, Germany.
# Author: Markus Niebel
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_U_BOOT_AE_ECC_QSPI) += u-boot-ae-ecc-qspi

#
# Paths and names
#
U_BOOT_AE_ECC_QSPI_VERSION	:= $(call remove_quotes,$(PTXCONF_U_BOOT_AE_ECC_QSPI_VERSION))
U_BOOT_AE_ECC_QSPI_MD5		:= $(call remove_quotes,$(PTXCONF_U_BOOT_AE_ECC_QSPI_MD5))
U_BOOT_AE_ECC_QSPI		:= u-boot-$(U_BOOT_AE_ECC_QSPI_VERSION)
U_BOOT_AE_ECC_QSPI_SUFFIX	= $(U_BOOT_SUFFIX)
U_BOOT_AE_ECC_QSPI_URL		= $(U_BOOT_URL)
U_BOOT_AE_ECC_QSPI_SOURCE	= $(U_BOOT_SOURCE)
U_BOOT_AE_ECC_QSPI_DIR		= $(BUILDDIR)/$(U_BOOT_AE_ECC_QSPI)-ae-ecc-qspi

U_BOOT_AE_ECC_QSPI_LICENSE	= $(U_BOOT_LICENSE)
U_BOOT_AE_ECC_QSPI_LICENSE_FILES = $(U_BOOT_LICENSE_FILES)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

U_BOOT_AE_ECC_QSPI_PATH		= $(U_BOOT_PATH)
U_BOOT_AE_ECC_QSPI_MAKE_OPT	= $(U_BOOT_MAKE_OPT)
U_BOOT_AE_ECC_QSPI_MAKE_PAR	= $(U_BOOT_MAKE_PAR)
U_BOOT_AE_ECC_QSPI_TAGS_OPT	= $(U_BOOT_TAGS_OPT)

$(STATEDIR)/u-boot-ae-ecc-qspi.prepare:
	@$(call targetinfo)
	cd $(U_BOOT_AE_ECC_QSPI_DIR) && \
		$(U_BOOT_AE_ECC_QSPI_PATH) \
		$(MAKE) $(U_BOOT_AE_ECC_QSPI_MAKE_OPT) $(PTXCONF_U_BOOT_AE_ECC_QSPI_CONFIG)
	@$(call touch)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

$(STATEDIR)/u-boot-ae-ecc-qspi.install:
	@$(call targetinfo)
	@$(call touch)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/u-boot-ae-ecc-qspi.targetinstall:
	@$(call targetinfo)
ifdef PTXCONF_U_BOOT_AE_ECC_QSPI_INSTALL_U_BOOT_AE_ECC_QSPI_IMG
	@install -D -m644 $(U_BOOT_AE_ECC_QSPI_DIR)/u-boot.img $(IMAGEDIR)/u-boot-ae-ecc-qspi.img
endif
ifdef PTXCONF_U_BOOT_AE_ECC_QSPI_INSTALL_TARGET
	@$(foreach target, $(PTXCONF_U_BOOT_AE_ECC_QSPI_INSTALL_TARGET), \
		tclsh $(PTXCONF_SYSROOT_HOST)/usr/sbin/byte_swap.tcl $(U_BOOT_AE_ECC_QSPI_DIR)/$(target) $(IMAGEDIR)/$(target).ae.ecc.bswap 8; \
		chmod 644 $(IMAGEDIR)/$(target).ae.ecc.bswap; \
	)
endif
	@$(call touch)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

$(STATEDIR)/u-boot-ae-ecc-qspi.clean:
	@$(call targetinfo)
	@$(call clean_pkg, U_BOOT_AE_ECC_QSPI)
	@rm -f $(IMAGEDIR)/u-boot-pbl-bin.ae.*

# vim: syntax=make
