# -*-makefile-*-
#
# Copyright (C) 2015-2022 TQ-Systems GmbH <oss@ew.tq-group.com>, D-82229 Seefeld, Germany.
# Author: Markus Niebel
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_DEVREGS) += devregs

#
# Paths and names
#
DEVREGS_VERSION	:= fdd9c39
DEVREGS_MD5	:= a912acccc28236217d56e4102c4f526a
DEVREGS		:= devregs-$(DEVREGS_VERSION)
DEVREGS_SUFFIX	:= tar.gz
DEVREGS_URL	:= https://github.com/boundarydevices/devregs.git;tag=$(DEVREGS_VERSION)
DEVREGS_SOURCE	:= $(SRCDIR)/$(DEVREGS).$(DEVREGS_SUFFIX)
DEVREGS_DIR	:= $(BUILDDIR)/$(DEVREGS)

DEVREGS_LICENSE	:= GPL-2.0
DEVREGS_LICENSE_FILES	:= file://COPYING;md5=5003fa041d799dd5dd5f646b74e36924

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

$(STATEDIR)/devregs.extract: $(STATEDIR)/autogen-tools

$(STATEDIR)/devregs.extract:
	@$(call targetinfo)
	@$(call clean, $(DEVREGS_DIR))
	@$(call extract, DEVREGS)
	cd $(DEVREGS_DIR) && [ -f configure ] || sh autogen.sh
	@$(call patchin, DEVREGS)
	@$(call touch)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

#
# autoconf
#
DEVREGS_CONF_TOOL	:= autoconf

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/devregs.targetinstall:
	@$(call targetinfo)

	@$(call install_init, devregs)
	@$(call install_fixup, devregs, PRIORITY, optional)
	@$(call install_fixup, devregs, SECTION, base)
	@$(call install_fixup, devregs, AUTHOR, "Markus Niebel, TQ-Systems GmbH")
	@$(call install_fixup, devregs, DESCRIPTION, missing)

	$(call install_copy, devregs, 0, 0, 0755, -, /usr/bin/devregs)
	@for i in $(shell cd $(DEVREGS_PKGDIR) && find etc -name "*.dat"); do \
		$(call install_copy, devregs, 0, 0, 0644, -, /$$i); \
	done

	@$(call install_finish, devregs)

	@$(call touch)

# vim: syntax=make
