# -*-makefile-*-
#
# Copyright (C) 2013-2022 TQ-Systems GmbH <oss@ew.tq-group.com>, D-82229 Seefeld, Germany.
# Author: Markus Niebel
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_PHYIO) += phyio

#
# Paths and names
#
PHYIO_VERSION	:= 0.4
PHYIO_MD5	:=
PHYIO		:= phyio
PHYIO_URL	:= file://local_src/$(PHYIO)
PHYIO_DIR	:= $(BUILDDIR)/$(PHYIO)

PHYIO_LICENSE	:= GPL-2.0
PHYIO_LICENSE_FILES := \
	file://COPYING;md5=0d80f2ab3d3f613e9853f13864203c46

PHYIO_INSTALL_ROOT	:= /usr
PHYIO_INSTALL_BIN	:= $(PHYIO_INSTALL_ROOT)/sbin

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

$(PHYIO_SOURCE):
	@$(call targetinfo)
	@$(call touch)

# ----------------------------------------------------------------------------
# extract
# ----------------------------------------------------------------------------

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

PHYIO_PATH	:= PATH=$(CROSS_PATH)
PHYIO_CONF_TOOL	:= NO

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

PHYIO_MAKE_OPT	:= \
	CROSS_COMPILE=$(PTXCONF_COMPILER_PREFIX) \
	all

PHYIO_MAKE_ENV	:= \
	$(CROSS_ENV) \
	CPPFLAGS=-I$(KERNEL_HEADERS_INCLUDE_DIR) $(CROSS_CPPFLAGS) \
	prefix=$(PHYIO_INSTALL_ROOT) \
	LDFLAGS=$(CROSS_CPPFLAGS)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

PHYIO_INSTALL_OPT	:= \
	install

PHYIO_INSTALL_ENV	:= \
	$(CROSS_ENV) \
	prefix=$(PHYIO_INSTALL_ROOT)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/phyio.targetinstall:
	@$(call targetinfo)
	@$(call install_init, phyio)
	@$(call install_fixup, phyio,PRIORITY,optional)
	@$(call install_fixup, phyio,SECTION,base)
	@$(call install_fixup, phyio,AUTHOR,"Markus Niebel, TQ-Systems GmbH")
	@$(call install_fixup, phyio,DESCRIPTION,missing)

	@$(call install_copy, phyio, 0, 0, 0755, $(PHYIO_INSTALL_BIN))
	@$(call install_copy, phyio, 0, 0, 0755, -, $(PHYIO_INSTALL_BIN)/phyio)
	@$(call install_copy, phyio, 0, 0, 0755, -, $(PHYIO_INSTALL_BIN)/smsc9303)
	@$(call install_copy, phyio, 0, 0, 0755, -, $(PHYIO_INSTALL_BIN)/ksz9031)
	@$(call install_copy, phyio, 0, 0, 0755, -, $(PHYIO_INSTALL_BIN)/dp83867)

	@$(call install_finish, phyio)
	@$(call touch)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

$(STATEDIR)/phyio.clean:
	@$(call targetinfo)
	-cd $(PHYIO_DIR) && make clean
	@$(call clean_pkg, PHYIO_DIR)

# vim: syntax=make
