# -*-makefile-*-
#
# Copyright (C) 2014-2022 TQ-Systems GmbH <oss@ew.tq-group.com>, D-82229 Seefeld, Germany.
# Author: Markus Niebel, Marco Felsch
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_XXD) += xxd

#
# Paths and names
#
XXD_VERSION	:= 1.10
XXD_MD5		:= 604cf64093fddc30adf41f1f371c9032
XXD		:= xxd-$(XXD_VERSION)
XXD_SUFFIX	:= tar.gz
XXD_URL		:= http://somos.crg4.com/$(XXD).$(XXD_SUFFIX)
XXD_SOURCE	:= $(SRCDIR)/$(XXD).$(XXD_SUFFIX)
XXD_DIR		:= $(BUILDDIR)/$(XXD)
XXD_LICENSE	:= public_domain

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

XXD_CONF_TOOL	:= NO
XXD_MAKE_ENV	:= \
	$(CROSS_ENV) \
	prefix=/usr

XXD_MAKE_OPT	:= \
	CC=$(CROSS_CC)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/xxd.targetinstall:
	@$(call targetinfo)

	@$(call install_init, xxd)
	@$(call install_fixup, xxd,PRIORITY,optional)
	@$(call install_fixup, xxd,SECTION,base)
	@$(call install_fixup, xxd,AUTHOR,"Markus Niebel, TQ-Systems GmbH")
	@$(call install_fixup, xxd,DESCRIPTION,missing)

	@$(call install_copy, xxd, 0, 0, 0755, -, /usr/bin/xxd)

	@$(call install_finish, xxd)

	@$(call touch)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

$(STATEDIR)/xxd.clean:
	@$(call targetinfo)
	@-cd $(XXD_DIR) && \
		$(XXD_ENV) $(XXD_PATH) $(MAKE) clean
	@$(call clean_pkg, XXD)

# vim: syntax=make
